using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using MikuMikuDance.XNA;
using MikuMikuDance.XNA.Model;
using MikuMikuDance.XNA.Stages;
using MikuMikuDance.XNA.Model.ModelData;

namespace MikuMikuDanceXNADemo3
{
    //カメラとライトモーションの再生
    /// <summary>
    /// MikuMikuDance for XNAのデモ
    /// このデモでは
    /// -ステージモーション(カメラモーションとライトモーション)の読み込み
    /// -ステージモーションの再生
    /// が書かれています
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        //MikuMikuDance for XNA
        MikuMikuDanceXNA mmd;
        //MMDモデルデータ
        MMDModel model;
        //MMDステージモーションデータ
        MMDStageMotion motion1, motion2;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            //デバイスがMMDXの必要条件を満たしているかチェック
            MikuMikuDanceXNA.InitialSetup(this, graphics, true);
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        /// <summary>
        /// LoadContent関数
        /// 各種ロード処理はここでロードを行っておくと良い
        /// </summary>
        protected override void LoadContent()
        {
            //MikuMikuDanceXNAを作成する
            mmd = new MikuMikuDanceXNA(this);
            //プロジェクトのContent内に追加してあるMiku.pmdモデルをロードする
            //ロードはMikuMikuDanceXNA.LoadModel関数で行う
            //(モデルデータはあにまさ氏よりお借りしました。このモデルファイルはMITライセンス適応外です)
            model = mmd.LoadModel("Miku", this, QuatTransform.Identity);
            //同じくContent内に追加してあるCamera.vmd, Light.vmdモーションをロードする
            //ステージ用モーションのロードはMikuMikuDanceXNA.LoadStageMotion関数で行う
            motion1 = mmd.LoadStageMotion("Camera");
            motion2 = mmd.LoadStageMotion("Light");
            //カメラのプレイヤーを呼び出し
            //モーションを0番トラックにセットする
            mmd.Camera.Player.SetMotion(0, motion1, true, mmd.Camera);
            //ライトのプレイヤーを呼び出し
            //モーションを0番トラックにセットする
            mmd.LightManager.Player.SetMotion(0, motion2, true, mmd.LightManager);
            
        }

        /// <summary>
        /// UnloadContent関数
        /// アンロードが必要な物はここでアンロードを行う
        /// </summary>
        protected override void UnloadContent()
        {
        }

        /// <summary>
        /// アップデート関数
        /// 毎フレーム処理する描画以外のコードをここに記述する
        /// </summary>
        /// <param name="gameTime">現在の時間のスナップショットを表すオブジェクト</param>
        protected override void Update(GameTime gameTime)
        {
            //XBoxコントローラーのBackボタンを押したら終了
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            //キーボードのEscキーを押したら終了
            if (Keyboard.GetState().IsKeyDown(Keys.Escape))
                this.Exit();
            
            //現在再生中でなければ
            if (!mmd.Camera.Player.IsPlay(0))
            {
                //0番トラックにセットされているモーションを再生する
                mmd.Camera.Player.Start(0, true);
                mmd.LightManager.Player.Start(0, true);
            }
            

            //モデル及び各モーションの再生処理はDrawableGameComponentを継承しているため
            //XNAにより自動で処理が行われる

            //XNA内部のUpdate処理を行う
            base.Update(gameTime);
        }

        /// <summary>
        /// Draw関数
        /// 毎フレーム処理する描画コードをここに記述する
        /// </summary>
        /// <param name="gameTime">現在の時間のスナップショットを表すオブジェクト</param>
        protected override void Draw(GameTime gameTime)
        {
            //画面をCornflowerBlue色で消去する
            GraphicsDevice.Clear(Color.CornflowerBlue);

            //モデルはDrawableGameComponentを継承しているため
            //XNAにより自動で描画される

            //XNA内部のDraw処理を行う
            base.Draw(gameTime);
        }
    }
}
